//+------------------------------------------------------------------+
//| Doc Sequential.mq4                                               |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers  8
#property indicator_color1   LimeGreen
#property indicator_color2   Orange
#property indicator_color3   Green
#property indicator_color4   Red
#property indicator_color5   LimeGreen
#property indicator_color6   Orange
#property indicator_color7   Green
#property indicator_color8   Red
#property indicator_width1   1
#property indicator_width2   1
#property indicator_width3   1
#property indicator_width4   1

//
//
//
//
//

extern int    TrendAlignIndicators        =    5;
extern int    TrendToolBars.Length        =    5;
extern int    PriceChannel.ChannelPeriod  =    5; //Price Channel Period
extern double PriceChannel.Risk           = 0.30; //channel narrowing factor (0...0,5)  
extern int    PriceChannel.Signal         =    1; //Display signals mode: 1-Signals & Stops; 0-only Stops; 2-only Signals;
extern int    PriceChannel.Line           =    1; //Display line mode: 0-no,1-yes  
extern int    PriceChannel.ColorBar       =    1; //Display color bars mode: 0-no,1-yes 
extern int    PriceChannel.TimeFrame      =    0; //TimeFrame in min
extern int    PriceChannel.Nbars          = 5000;
extern int    MaBars.MA_Period            =    5;
extern int    MaBars.MA_Mode              =    0;
extern int    CciBars.PeriodCCI           =    5;
extern int    CciBars.CCI_OB              =  150;
extern int    CciBars.CCI_OS              = -150;
extern int    CciBars.TF                  =    0;
extern int    PrecisionTrend.avgPeriod    =   30;
extern double PrecisionTrend.sensitivity  =    1;
extern int    candleBodyWidth             =    3;

//
//
//
//
//

double uplBuffer[];
double uprBuffer[];
double dnlBuffer[];
double dnrBuffer[];
double upwlBuffer[];
double upwrBuffer[];
double dnwlBuffer[];
double dnwrBuffer[];
double trend[];

int    TrendChangeValue=4;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,uplBuffer);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnlBuffer);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,uprBuffer);  SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dnrBuffer);  SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,upwlBuffer); SetIndexStyle(4,DRAW_HISTOGRAM); SetIndexStyle(4,EMPTY,EMPTY,candleBodyWidth);
   SetIndexBuffer(5,dnwlBuffer); SetIndexStyle(5,DRAW_HISTOGRAM); SetIndexStyle(5,EMPTY,EMPTY,candleBodyWidth);
   SetIndexBuffer(6,upwrBuffer); SetIndexStyle(6,DRAW_HISTOGRAM); SetIndexStyle(6,EMPTY,EMPTY,candleBodyWidth);
   SetIndexBuffer(7,dnwrBuffer); SetIndexStyle(7,DRAW_HISTOGRAM); SetIndexStyle(7,EMPTY,EMPTY,candleBodyWidth);

   TrendAlignIndicators = MathMin(MathMax(TrendAlignIndicators,3),5);
      switch(TrendAlignIndicators)
      {
         case 3 :  TrendChangeValue = 0; break;
         case 4 :  TrendChangeValue = 2; break;
         case 5 :  TrendChangeValue = 4;
      }
               
   return(0);
}

//
//
//
//
//

#define _name "DOC_seq"
int deinit()
{
   for(int i=ObjectsTotal(); i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,7) == _name)
             ObjectDelete(name);  
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,r,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit=MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(trend,0) != Bars) ArrayResize(trend,Bars);

      
   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      trend[r] = trend[r-1];

      //
      //
      //    collect indicators states
      //
      //

         int currentState = 0;
            
            double ptValue1 = iCustom(NULL,0,"precision trend",PrecisionTrend.avgPeriod,PrecisionTrend.sensitivity,0,i);
            double ptValue2 = iCustom(NULL,0,"precision trend",PrecisionTrend.avgPeriod,PrecisionTrend.sensitivity,1,i);
               if (ptValue1>ptValue2)
                     currentState += 1;
               else  currentState -= 1;
            double ttbValue1 = iCustom(NULL,0,"Trend_tool_bars",TrendToolBars.Length,0,i);
               if (ttbValue1 == 1)
                     currentState += 1;
               else  currentState -= 1;
            double pcValue1 = iCustom(NULL,0,"price channel stop bars",PriceChannel.ChannelPeriod,PriceChannel.Risk,0,i);
               if (pcValue1>=0)
                     currentState += 1;
               else  currentState -= 1;
            double mabValue1 = iCustom(NULL,0,"ma bars simo",MaBars.MA_Period,MaBars.MA_Mode,0,i);
            double mabValue2 = iCustom(NULL,0,"ma bars simo",MaBars.MA_Period,MaBars.MA_Mode,2,i);
               if (mabValue1 == 1 || mabValue2 == 1)
                     currentState += 1;
               else  currentState -= 1;
            double cciValue1 = iCustom(NULL,0,"cci bars simo",CciBars.PeriodCCI,CciBars.CCI_OB,CciBars.CCI_OS,0,i);
            double cciValue2 = iCustom(NULL,0,"cci bars simo",CciBars.PeriodCCI,CciBars.CCI_OB,CciBars.CCI_OS,2,i);
               if (cciValue1 == 1 || cciValue2 == 1)
                     currentState += 1;
               else  currentState -= 1;
            
      //
      //
      //
      //
      //
            
      if (currentState >  TrendChangeValue) trend[r] =  1;
      if (currentState < -TrendChangeValue) trend[r] = -1;
      bool isLight = false;
         if (currentState > -4 && trend[r] == -1) isLight = true;
         if (currentState <  4 && trend[r] ==  1) isLight = true;

      //
      //
      //
      //
      //

         uplBuffer[i]  = EMPTY_VALUE;
         uprBuffer[i]  = EMPTY_VALUE;
         dnlBuffer[i]  = EMPTY_VALUE;
         dnrBuffer[i]  = EMPTY_VALUE;
         upwlBuffer[i] = EMPTY_VALUE;
         upwrBuffer[i] = EMPTY_VALUE;
         dnwlBuffer[i] = EMPTY_VALUE;
         dnwrBuffer[i] = EMPTY_VALUE;
         
         if (trend[r] == 1)
         if (isLight)
            {
               uplBuffer[i]  = High[i];
               dnlBuffer[i]  = Low[i];
               upwlBuffer[i] = MathMax(Open[i],Close[i]);
               dnwlBuffer[i] = MathMin(Open[i],Close[i]);
            }               
         else
            {
               uprBuffer[i]  = High[i];
               dnrBuffer[i]  = Low[i];
               upwrBuffer[i] = MathMax(Open[i],Close[i]);
               dnwrBuffer[i] = MathMin(Open[i],Close[i]);
            }
            
         if (trend[r] == -1)
         if (isLight)
            {
               uplBuffer[i] = Low[i];
               dnlBuffer[i] = High[i];
               upwlBuffer[i] = MathMin(Open[i],Close[i]);
               dnwlBuffer[i] = MathMax(Open[i],Close[i]);
            }               
         else
            {
               uprBuffer[i]  = Low[i];
               dnrBuffer[i]  = High[i];
               upwrBuffer[i] = MathMin(Open[i],Close[i]);
               dnwrBuffer[i] = MathMax(Open[i],Close[i]);
            }
    }
   return(0);
}

